#
# Conditional build:
%bcond_with	initrd		# don't build initrd version
%bcond_with	dietlibc	# link initrd version with static glibc instead of dietlibc
%bcond_without	tests		# don't perform "make test"

Summary:	Tool for creating and maintaining software RAID devices
Summary(pl.UTF-8):	Narzędzie do tworzenia i obsługi programowych macierzy RAID
Name:		mdadm
Version:	4.0
Release:	1
License:	GPL v2+
Group:		Base
Source0:	https://www.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.xz
# Source0-md5:	2cb4feffea9167ba71b5f346a0c0a40d
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.cron
Source4:	%{name}-checkarray
URL:		https://www.kernel.org/pub/linux/utils/raid/mdadm/
BuildRequires:	groff
BuildRequires:	rpmbuild(macros) >= 1.213
%if %{with initrd}
	%if %{with dietlibc}
BuildRequires:	dietlibc-static
	%else
BuildRequires:	glibc-static
	%endif
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires(post,preun):	/sbin/chkconfig
Requires:	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.2.4-2
Suggests:	crondaemon
%{!?with_initrd:Obsoletes:	mdadm-initrd < %{version}-%{release}}
Obsoletes:	mdctl
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir		/sbin

%description
This package includes tool you need to set up and maintain a software
RAID device under Linux. It's thought as an alternative to raidtools
package.

%description -l pl.UTF-8
Pakiet ten zawiera narzędzie potrzebne do tworzenia i obsługi
programowych macierzy RAID. Program ten jest pomyślany jako
alternatywa dla pakietu raidtools.

%package initrd
Summary:	Tool for maintaining software RAID devices - initrd version
Summary(pl.UTF-8):	Narzędzie do obsługi programowych macierzy RAID, wersja dla initrd
Group:		Base
Conflicts:	geninitrd < 10000.10

%description initrd
Tool for maintaining software RAID devices - statically linked for
initrd.

%description initrd -l pl.UTF-8
Narzędzie do zarządzania programowymi macierzami RAID - statycznie
skonsolidowane na potrzeby initrd.

%prep
%setup -q

%build
%if %{with initrd}
%if %{with dietlibc}
%{__make} mdadm \
	CC="diet %{__cc} %{rpmcflags} %{rpmcppflags} %{rpmldflags} -Os -static" \
	CWFLAGS="-Wall"
mv -f mdadm initrd-mdadm
%{__make} clean
diet %{__cc} -DUCLIBC -DMDASSEMBLE_AUTO -DMDASSEMBLE %{rpmcflags} %{rpmcppflags} %{rpmldflags} -Os -static \
	-o initrd-mdassemble \
	mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c lib.c \
	super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
	platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c mdopen.c maps.c xmalloc.c
%else
%{__make} mdadm.static \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}"
mv -f mdadm.static initrd-mdadm
%{__make} clean
%{__cc} -DMDASSEMBLE_AUTO -DMDASSEMBLE %{rpmcflags} %{rpmcppflags} %{rpmldflags} -DHAVE_STDINT_H -static \
	-o initrd-mdassemble \
	mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c lib.c \
	super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
	platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c mdopen.c maps.c xmalloc.c
%endif
%{__make} clean
%endif

%{__make} mdassemble \
	MDASSEMBLE_AUTO=1 \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}" \
	SYSCONFDIR="%{_sysconfdir}"
mv mdassemble regular-mdassemble
%{__make} clean

%{__make} all mdadm mdadm.8 \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}" \
	SYSCONFDIR="%{_sysconfdir}"

%{?with_tests:%{__make} test}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man{5,8},/etc/{rc.d/init.d,sysconfig,cron.d}}

%if %{with initrd}
install -d $RPM_BUILD_ROOT%{_libdir}/initrd
install -p initrd-mdadm $RPM_BUILD_ROOT%{_libdir}/initrd/mdadm
install -p initrd-mdassemble $RPM_BUILD_ROOT%{_libdir}/initrd/mdassemble
ln -s mdadm $RPM_BUILD_ROOT%{_libdir}/initrd/mdctl
%endif

install -p regular-mdassemble $RPM_BUILD_ROOT%{_sbindir}/mdassemble
install -p mdadm $RPM_BUILD_ROOT%{_sbindir}

cp -p md*.5 $RPM_BUILD_ROOT%{_mandir}/man5
cp -p md*.8 $RPM_BUILD_ROOT%{_mandir}/man8

cp -p mdadm.conf-example $RPM_BUILD_ROOT%{_sysconfdir}/mdadm.conf

ln -s mdadm $RPM_BUILD_ROOT%{_sbindir}/mdctl

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/cron.d/mdadm-checkarray
install -p %{SOURCE4} $RPM_BUILD_ROOT%{_sbindir}/mdadm-checkarray

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service mdadm restart "RAID monitoring"

%preun
if [ "$1" = "0" ]; then
	%service mdadm stop
	/sbin/chkconfig --del mdadm
fi

%files
%defattr(644,root,root,755)
%doc ANNOUNCE* ChangeLog TODO
%attr(755,root,root) %{_sbindir}/mdadm
%attr(755,root,root) %{_sbindir}/mdadm-checkarray
%attr(755,root,root) %{_sbindir}/mdassemble
%attr(755,root,root) %{_sbindir}/mdctl
%attr(640,root,root) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/mdadm.conf
%{_mandir}/man5/mdadm.conf.5*
%{_mandir}/man8/mdadm.8*
%{_mandir}/man8/mdassemble.8*
%{_mandir}/man8/mdmon.8*
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%config(noreplace) %attr(640,root,root) /etc/cron.d/mdadm-checkarray

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/initrd/mdadm
%attr(755,root,root) %{_libdir}/initrd/mdassemble
%attr(755,root,root) %{_libdir}/initrd/mdctl
%endif
%changelog
* Tue Jan 10 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mdadm.git;a=log;h=master

* Tue Jan 10 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 4b3081c
- up to 4.0 (new maintainer)

* Tue Mar 29 2016 Jakub Bogusz <qboosh@pld-linux.org> 6737f60
- updated to 3.4 (now supports journalled RAID5/6 and clustered RAID1)

* Tue Aug 11 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> bae2bf9
- up to 3.3.4

* Sun Mar 01 2015 Elan Ruusamäe <glen@delfi.ee> 028b344
- x32 rebuild
- release 2 (by relup.sh)

* Fri Aug 22 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> a7087c9
- up to 3.3.2

* Tue Aug 05 2014 Marcin Krol <hawk@tld-linux.org> 3441ea1
- upstream fix for array assembling

* Thu Jun 05 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> df9a0ef
- up to 3.3.1

* Wed May 14 2014 Elan Ruusamäe <glen@delfi.ee> ec5e523
- suggest/require crondaemon
- release 5 (by relup.sh)

* Sat Feb 01 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> d8df675
- rel 4; build mdassemble separately and turn on MDASSEMBLE_AUTO, so we get working mdassemble

* Sat Feb 01 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> d8d18d9
- rel 3; install non-initrd mdassemble, too (for geninitrd use)

* Fri Jan 31 2014 Jan Rękorajski <baggins@pld-linux.org> 26a8f59
- disable/remove initrd subpackage
- rel 2

* Tue Sep 10 2013 Jakub Bogusz <qboosh@pld-linux.org> 063f2ee
- updated to 3.3

* Thu Oct 25 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> f06941a
- up to 3.2.6

* Sun May 20 2012 Paweł Sikora <pluto@pld-linux.org> 32443f6
- updated to 3.2.5.

* Fri May 11 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 92d7937
- up to 3.2.4; drop obsolete patches

* Sat Apr 28 2012 Jan Rękorajski <baggins@pld-linux.org> d70df71
- rel 4
- drop initramfs package, it was never properly tested, never really updated
  and initramfs-tools functionality is obsoleted by dracut

* Thu Mar 08 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> b8dae64
- rel 3; fix but when activating bitmap on array fails sometimes

* Thu Feb 16 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> e802c54
- rel 2; fix segv at assemble (sometimes only)

* Wed Dec 28 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 2da6dd4
- up to 3.2.3

* Mon Dec 19 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> bba284b
- release 2

